#include <vector>
#include <string>
#define FILE_NAME_SIZE 256

extern unsigned long bufferSize;
class Frame
{
    private:
        unsigned int lines;
        unsigned int number;
        unsigned int actualBufferSize;
        unsigned int prevOpened;
        unsigned int totalFrames;
        unsigned int startLine;
        unsigned int totalFileLines;
        unsigned int scrollBackOffset;
        unsigned int scrollRightOffset;
        fpos_t prevPosition;
        WINDOW *win;

        vector <string> Screen;
        vector <string> ignoreList;

        char fileName[FILE_NAME_SIZE];
        FILE *fin;
        unsigned long findPos(unsigned long =0);
        int setVariables();
        unsigned int findTotalFileLines();

    public:
        Frame();
        ~Frame();
        // Filename, Number in queue, Total number of frames.
        Frame(char* , unsigned int , unsigned int);
        reSize(unsigned int);
        unsigned int setScrollBack(unsigned int);
        unsigned int incrScrollBack(unsigned int = 1);
        unsigned int decrScrollBack(unsigned int = 1);
        unsigned int setScrollRight(unsigned int);
        unsigned int incrScrollRight(unsigned int = 1);
        unsigned int decrScrollRight(unsigned int = 1);
        read();
        print();
};
    
