//
// Programmer: Andrew MacKenzie
//
// Date: 
//
// Version: 
//
// Description:
//

#include <stdio.h>
#include <stdlib.h>

#include <ncurses.h>
#include <signal.h>
#include <time.h>
#include <vector>
#include <unistd.h>
#include <string>
#include <unistd.h>

#include "Frame.h"
#include "Util.h"

vector <char *> fileList;
vector<Frame> frameList;

FILE * ferr=NULL;

unsigned long delay;
unsigned long bufferSize;

int init()
{
    for (int i=0; i<fileList.size(); i++)
    {
        frameList.push_back( Frame(fileList[i],i, fileList.size()) );
    }

    delay=3; // Second(s)
}

void display()
{
    int c;
    int scrollUp=0;
    int scrollRight=0;
    int scrollLeft=0;
    int scrollDown=0;
    int reset=0;

    //nodelay(stdscr, TRUE);
    halfdelay(delay);
    keypad(stdscr, TRUE);
    noecho();
    while(1)
    {

        for (int i=0; i<frameList.size(); i++)
        {
            if ( scrollUp )
                frameList[i].incrScrollBack(scrollUp);
            if ( scrollDown )
                frameList[i].decrScrollBack(scrollDown);
            if ( scrollLeft )
                frameList[i].decrScrollRight(scrollLeft);
            if ( scrollRight )
                frameList[i].incrScrollRight(scrollRight);
            if ( reset )
            {
                frameList[i].setScrollBack(0);
                frameList[i].setScrollRight(0);
            }

            frameList[i].read();
            frameList[i].print();
        }

        scrollUp = 0;
        scrollDown = 0;
        reset = 0;
        scrollRight = 0;
        scrollLeft = 0;

        if ( (c=getch()) != ERR )
        {
            // do something.
            // Handle our character.
            fprintf(ferr,"Got : %d\n",c);
            switch(c)
            {
                case KEY_UP:
                    scrollUp=1;
                    break;
                 case KEY_RIGHT:
                    scrollRight=1;
                    break;
                case KEY_LEFT:
                    scrollLeft=1;
                    break;
                case KEY_DOWN:
                    scrollDown=1;
                    break;
                case KEY_NPAGE:
                    scrollDown=5;
                    break;
                case KEY_PPAGE:
                    scrollUp=5;
                    break;
                case ' ':
                    reset=1;
                    break;
                case 'q':
                case 'Q':
                    clean_exit();
                default:
                    break;
            }
        }
    
        //sleep(delay);
    }

}

int usage(string prog)
{
    printf("Usage:\n\n\t%s [-d buffer_size] <file1> <file2> ...\n\n", prog.c_str());
}

extern char *optarg;
extern int optind, opterr, optopt;

int main( int argc, char ** argv )
{
    (void) signal(SIGINT, sig_int);

    char c;

    time_t start, end;
    time_t tstart, tend;

//#ifdef __DEBUG__
    ferr = fopen("err.txt","w");
    // Set to non-buffered.
    setbuf(ferr,NULL);
//#endif __DEBUG__

    // Set default values for command line args.
    bufferSize = 100;

    while ( (c=getopt(argc, argv, "d:")) != -1)
    {
        switch(c)
        {
            case 'd':
                printf("bufferSize");
                bufferSize=atoi(optarg);
                fprintf(ferr,"=%d\n",bufferSize);
                fprintf(ferr,"optarg=%s\n",optarg);
                fflush(ferr);
                break;
            default:
                printf("Unknown option <%c>\n",c);
                usage(argv[0]);
                clean_exit();
        }
    }
    // Get each file...
    if ( optind < argc )
    {

        for (int i=optind; i<argc; i++)
        {
            fileList.push_back(argv[i]);
        }
    }
    else
    {
        printf("No files dipshit!\n");
        usage(string(argv[0]));
        clean_exit();
    }

    // Initialize our ncurses window.
    initscr(); cbreak(); clear(); refresh(); 

    init();

    display();

    clean_exit();

    return 0;
}
